config/routes.rb
Rails.application.routes.draw do
  ## OAUTH ##
  devise_scope :user do
    get "omniauth/franceconnect/callback" => "omniauth_callbacks#franceconnect"
  end

  devise_for :super_admins # necessary for helpers like super_admin_signed_in?
  devise_scope :super_admin do
    get "omniauth/github/callback" => "omniauth_callbacks#github"
  end

  ## ADMIN ##
  get "connexion_super_admins", to: "welcome#super_admin"

  delete "super_admins/sign_out" => "super_admins/sessions#destroy"

  namespace :super_admins do
    resources :agents do
      get "sign_in_as", on: :member
      post :invite, on: :member
    end
    resources :super_admins
    resources :organisations
    resources :services
    resources :motifs
    resources :territories
    resources :users do
      get "sign_in_as", on: :member
    end
    root to: "agents#index"

    authenticate :super_admin do
      match "/delayed_job" => DelayedJobWeb, anchor: false, via: %i[get post]
    end
  end
  get "super_admin", to: redirect("super_admins", status: 301)

  devise_scope :user do
    get "users/pending_registration" => "users/registrations#pending"
    get "invitation", to: "users/invitations#invitation", as: "invitations_landing"
  end

  ## APP ##
  devise_for :users,
             controllers: { registrations: "users/registrations", sessions: "users/sessions", passwords: "users/passwords", confirmations: "users/confirmations", invitations: "users/invitations" }

  namespace :users do
    resource :rdv_wizard_step, only: %i[new create]
    resources :rdvs, only: %i[index create show edit update] do
      member do
        get :creneaux
        put :cancel
      end
    end
    resource :user_name_initials_verification, only: %i[new create], controller: "user_name_initials_verification"
    post "file_attente", to: "file_attentes#create_or_delete"
  end
  resources :stats, only: :index
  get "stats/agents", to: "stats#agents", as: "agents_stats"
  get "stats/organisations", to: "stats#organisations", as: "organisations_stats"
  get "stats/rdvs", to: "stats#rdvs", as: "rdvs_stats"
  get "stats/users", to: "stats#users", as: "users_stats"
  get "stats/receipts", to: "stats#receipts", as: "receipts_stats"
  get "stats/:departement", to: "stats#index", as: "departement_stats"

  authenticate :user do
    get "/users/informations", to: "users/users#edit"
    patch "users/informations", to: "users/users#update"
    resources :relatives, except: %i[index show], controller: "users/relatives"
  end
  authenticated :user do
    get "/users/rdvs", to: "users/rdvs#index"
  end

  devise_for :agents, controllers: {
    invitations: "admin/invitations_devise", # only using the accept route here
    sessions: "agents/sessions",
    passwords: "agents/passwords",
  }

  devise_scope :agent do
    get "agents/edit" => "agents/registrations#edit", as: "edit_agent_registration"
    put "agents" => "agents/registrations#update", as: "agent_registration"
    delete "agents" => "agents/registrations#destroy", as: "delete_agent_registration"
    namespace :agents do
      resource :preferences, only: %i[show update]
    end
  end

  namespace :api do
    namespace :v1 do
      mount_devise_token_auth_for "AgentWithTokenAuth", at: "auth"
      resources :absences, except: %i[new edit]
      resources :agents, only: %i[index]
      resources :users, only: %i[create index show update] do
        get :invite, on: :member
        post :invite, on: :member
      end
      resources :user_profiles, only: [:create]
      resources :organisations, only: %i[index] do
        resources :users, only: %i[index show]
        resources :motifs, only: %i[index]
        resources :rdvs, only: %i[index]
      end

      resources :invitations, param: "token", only: [:show]
    end
  end

  resources :organisations, only: %i[new create]

  authenticate :agent do
    namespace "admin" do
      resources :territories, only: %i[update show] do
        scope module: "territories" do
          resources :agent_territorial_roles, only: %i[index new create destroy]
          resources :agent_territorial_access_rights, only: %i[update]
          resources :webhook_endpoints, except: %i[show]
          resources :agents
          resources :teams do
            collection do
              get :search
            end
          end
          resource :user_fields, only: %i[edit update]
          resource :rdv_fields, only: %i[edit update]
          resource :motif_fields, only: %i[edit update]
          resource :sms_configuration, only: %i[show edit update]
          resources :zone_imports, only: %i[new create]
          resources :zones, only: [:index] # exports only
          resources :sectors do
            resources :zones
            resources :sector_attributions, only: %i[new create destroy], as: :attributions
            delete "/zones" => "zones#destroy_multiple"
          end
          get "sectorisation_test" => "sectorisation_tests#search"
        end
      end

      # Routes pour les ressources du calendrier.
      # TODO trouver un meilleur nom pour éviter la nécessité de ce commentaire :)
      resources :agents, only: [], module: :agents do
        resources :plage_ouvertures, only: [:index]
        resources :rdvs, only: [:index]
        resources :absences, only: [:index]
      end

      resources :organisations do
        resources :plage_ouvertures, except: %i[index new]
        resources :agent_searches, only: :index, module: "creneaux"
        resources :slots, only: :index
        resources :lieux, except: :show
        resources :motifs
        resources :rdvs_collectifs, only: %i[index new create edit update] do
          collection do
            resources :motifs, only: [:index], as: :rdvs_collectif_motifs, controller: "rdvs_collectifs/motifs"
          end
        end
        resources :rdvs, except: [:new] do
          post :new_participation
          collection do
            post :export
          end
        end
        scope module: "organisations" do
          resource :setup_checklist, only: [:show]
          resources :stats, only: :index do
            collection do
              get :rdvs
              get :users
            end
          end
        end
        resources :users do
          member do
            post :invite
            get :link_to_organisation
          end
          collection do
            get :search
          end
          resources :referents, only: %i[index create destroy]
        end
        resources :absences, except: %i[index show new]
        resources :agent_roles, only: %i[edit update]
        resources :agent_agendas, only: %i[show] do
          put :toggle_displays, on: :member
        end
        resources :agents, only: %i[index destroy] do
          resources :absences, only: %i[index new]
          resources :plage_ouvertures, only: %i[index new]
          resources :stats, only: :index do
            collection do
              get :rdvs
              get :users
            end
          end
        end
        resources :invitations, only: [:index] do
          post :reinvite, on: :member
        end
        resource :merge_users, only: %i[new create]
        resource :rdv_wizard_step, only: [:new] do
          get :create
        end
        devise_for :agents, controllers: { invitations: "admin/invitations_devise" }, only: :invitations
        get "support", to: "static_pages#support"
      end

      resources :jours_feries, only: [:index]
    end
  end
  authenticated :agent do
    root to: "admin/organisations#index", as: :authenticated_agent_root, defaults: { follow_unique: "1" }
  end

  { contact: "contact", mds: "mds", accessibility: "accessibility" }.each do |k, v|
    get v => "static_pages##{k}"
  end

  ## Shorten urls for SMS

  get "r", to: redirect("users/rdvs", status: 301), as: "rdvs_short"

  get "r/:id", to: (redirect do |path_params, req|
    query_params = format_redirect_params(req.params)
    "users/rdvs/#{path_params[:id]}#{query_params}"
  end), as: "rdv_short"

  get "prdv", to: (redirect do |_path_params, req|
    query_params = format_redirect_params(req.params)
    "prendre_rdv#{query_params}"
  end), as: "prendre_rdv_short"

  get "r/:id/cr", to: (redirect do |path_params, req|
    query_params = format_redirect_params(req.params)
    "users/rdvs/#{path_params[:id]}/creneaux#{query_params}"
  end), as: "creneaux_users_rdv_short"

  def format_redirect_params(params)
    # we rename the short parameter tkn
    params[:invitation_token] ||= params.delete(:tkn) if params[:tkn]
    params.delete(:id) # id is passed through path_params
    params.values.any? ? "?#{params.to_query}" : ''
  end

  ##

  get "accueil_mds" => "welcome#welcome_agent"
  post "/" => "welcome#search"
  get "departement/:departement", to: "welcome#welcome_departement", as: "welcome_departement"
  post "departement/:departement" => "welcome#search_departement"
  get "departement/:departement/:service", to: "welcome#welcome_service", as: "welcome_service"
  resources :lieux, only: %i[index show]
  root "welcome#index"

  get "/prendre_rdv", to: "search#search_rdv"

  # rubocop:disable Style/FormatStringToken
  # temporary route after admin namespace introduction
  get "/organisations/*rest", to: redirect('admin/organisations/%{rest}')
  # old agenda rule was bookmarked by some agents
  get "admin/organisations/:organisation_id/agents/:agent_id", to: redirect("/admin/organisations/%{organisation_id}/agent_agendas/%{agent_id}")
  # rubocop:enable Style/FormatStringToken

  # LetterOpener
  mount LetterOpenerWeb::Engine, at: "/letter_opener" if Rails.env.development?
end

app/controllers/search_controller.rb
# frozen_string_literal: true

class SearchController < ApplicationController
  include TokenInvitable

  def search_rdv
    @context = SearchContext.new(current_user, search_params.to_h)
  end

  private

  def search_params
    params.permit(
      :latitude, :longitude, :address, :city_code, :departement, :street_ban_id,
      :service_id, :lieu_id, :date, :motif_search_terms, :motif_name_with_location_type, :motif_category,
      :invitation_token, organisation_ids: []
    )
  end
end

app/views/search/_address_form.html.slim
#search_form
  = simple_form_for :search, url: prendre_rdv_path, method: :get do |f|
    = f.input :departement, as: :hidden, input_html: { name: "departement", value: context.departement }
    = f.input :city_code,  as: :hidden, input_html: { name: "city_code", value: context.city_code }
    = f.input :street_ban_id, as: :hidden, input_html: { name: "street_ban_id", value: context.street_ban_id }
    = f.input :latitude, as: :hidden, input_html: { name: "latitude", value: context.latitude }
    = f.input :longitude, as: :hidden, input_html: { name: "longitude" , value: context.longitude }
    .form-row.d-flex.justify-content-md-center
        / TODO: change input name to address and change whereInput in application.js
        .col-lg-9= f.input :where, label: "Votre adresse", placeholder: "ex : 21 rue Anatole France, Calais", input_html: { value: context.address, name: "address", class: "form-control-lg places-js-container" }, wrapper_html: { class: "mb-1 mb-lg-0" }
        .col-lg-3.align-self-end
          = f.button :button, id: "search_submit", class: "btn-secondary btn-lg w-100 text-center", disabled: true do
            i.fa.fa-search>
            | Rechercher

app/views/search/_address_selection.html.slim
section.py-2
    .container
      .row
        .col-lg-12.justify-content-md-center
          .mb-5= render "address_form", context: context

app/views/search/_banner.html.slim
section.py-2
  .container
    .col-lg-12.justify-content-md-center
      h1.text-white
        - if context.invitation?
          | Vous avez été invité(e) à prendre&nbsp;
          span.text-secondary rendez-vous
        - else
          | Prenez&nbsp;
          span.text-secondary rendez-vous en ligne
        br
          | avec votre département&nbsp;
          - if context.departement.present?
            | le &nbsp;
            span.text-secondary #{context.departement}
      - if context.selected_motif.present?
        h2.text-white.mb-4 #{motif_name_with_location_type(context.selected_motif)}

app/views/search/_creneau_selection.html.slim
section.bg-light.p-4
  .container
    .card.mb-3
      .card-body
        h5.card-title= context.lieu.name
        h6.card-subtitle.mb-3= context.lieu.address
        - if context.unique_motifs_by_name_and_location_type.present?
          = render "creneaux", lieu: context.lieu, creneaux: context.creneaux, date_range: context.date_range, departement: context.departement, address: context.address, max_booking_delay: context.max_booking_delay, city_code: context.city_code, next_availability: context.next_availability, query: context.query
        - else
          .alert.alert-warning= "Le motif <b>#{context.selected_motif.name}</b> n'est plus disponible à la réservation à <b>#{context.lieu.name}</b>".html_safe

app/views/search/_creneaux.html.slim
div id="creneaux-lieu-#{lieu.id}"
  .row
    - previous_from_date = date_range.begin - 7.days
    - if date_range.begin > Time.zone.today
      .col-12.col-md-auto.mb-2.mb-md-0.d-flex.align-items-center.justify-content-center
        = link_to prendre_rdv_path(query.merge(date: previous_from_date)), class: "btn btn-primary", data: { disable_with: "..." } do
          i.fa.fa-chevron-left
          span.d-md-none.ml-1<
            | sem. précédente

    .col
      .row
        - date_range.each do |date|
          .col-6.col-md-3.col-lg
            p.text-center
              strong= l(date, format: "%A")
              br
              = l(date, format: "%d %b")
            - creneaux_for_date = creneaux.group_by { |c| c.starts_at.to_date }.select { |k, v| k == date }

            - if creneaux_for_date.any? && creneaux_for_date[date].first.respects_max_booking_delay?
              - creneaux_for_date.each do |date, creneaux|
                - creneaux.sort_by(&:starts_at).each do |creneau|
                  - if creneau.motif.restriction_for_rdv.blank?
                    = link_to new_users_rdv_wizard_step_path(query.merge(motif_id: creneau.motif.id, starts_at: creneau.starts_at)), "data-turbolinks": false, class: "btn btn-light mr-1 mb-1 w-100" do
                      = l(creneau.starts_at, format: "%H:%M")
                      - if creneau.motif.follow_up?
                        br
                        small= creneau.agent.short_name
                  - else
                    = link_to "#", "data-turbolinks": false, data: { toggle: "modal", target: "#js-rdv-restriction-motif#{creneau.starts_at.to_i}" }, class: "btn btn-light mr-1 mb-1 w-100" do
                      = l(creneau.starts_at, format: "%H:%M")
                      - if creneau.motif.follow_up?
                        br
                        small= creneau.agent.short_name

                    =  render "/common/modal", id: "js-rdv-restriction-motif#{creneau.starts_at.to_i}" , title: "À lire avant de prendre un rendez-vous", confirm_path: new_users_rdv_wizard_step_path(query.merge(motif_id: creneau.motif.id, starts_at: creneau.starts_at)) do
                      = ActionController::Base.helpers.auto_link(simple_format(creneau.motif.restriction_for_rdv), html: { target: "_blank"})
            - elsif date >= (Time.now + max_booking_delay.seconds).to_date
              p.text-center.text-muted
                | Date fermée à la reservation
            - elsif creneaux.any?
              p.text-center
                i.fa.fa-minus.text-muted

        - if next_availability
          .position-absolute.h-100.w-100.bg-overlay.d-flex.align-items-center.justify-content-center
            = link_to prendre_rdv_path(query.merge(date: next_availability.starts_at)), class: "btn btn-light", data: { disable_with: "..." } do
              .d-flex.align-items-center
                div
                  | Prochaine disponibilité le
                  br
                  strong= l(next_availability.starts_at, format: :human)
                .ml-2
                  i.fa.fa-chevron-right
    - if params[:date].blank? || (params[:date].to_date + 6.days) < (Time.now + max_booking_delay.seconds).to_date
      .col-12.col-md-auto.mt-2.mt-md-0.d-flex.align-items-center.justify-content-center
        = link_to prendre_rdv_path(query.merge(date: date_range.end + 1.day)), class: "btn btn-primary", data: { disable_with: "..." } do
          span.d-md-none.mr-1
            | sem. prochaine
          i.fa.fa-chevron-right

app/views/search/_lieu_selection.html.slim
section.bg-light.p-4
  .container
    h3.font-weight-bold = t(".select_lieu")
    p = t(".lieu_available", count: context.lieux.size)
    - context.lieux.each do |lieu|
      - next_availability = context.next_availability_by_lieux[lieu.id]
      .card.mb-3 class=("card-hoverable" if next_availability)
        .card-body
          .row
            .col-md
              h4.card-title.mb-3.mt-0.text-success.font-weight-bold= lieu.name
              h5.card-subtitle.mb-2= lieu.address
              h6.card-subtitle= context.selected_motif.service.name
            .col-md.align-self-center.pt-3.pt-md-0.position-static
              - if next_availability
                = link_to prendre_rdv_path(context.query.merge(lieu_id: lieu.id, date: next_availability.starts_at)), class: "d-block stretched-link" do
                  .row
                    .col
                      = t(".next_availability")
                      br
                      strong= l(next_availability.starts_at, format: :human)
                    .col-auto.align-self-center
                      i.fa.fa-chevron-right
              - else
                em = t(".no_availability")

app/views/search/_motif_selection.html.slim
section.bg-light.p-4
  .container
    - if context.unique_motifs_by_name_and_location_type.empty?
      .card
        .card-body
          - if context.invitation?
            h4.font-weight-bold Nous sommes désolés, un problème semble s'être produit pour votre invitation.
            = mail_to "support@rdv-solidarites.fr",
              subject: "[Problème Invitation]",
              class: "btn btn-primary" do
              span>
                i.fa.fa-envelope
              | Envoyer une demande à l'équipe technique
          - else
            h4.font-weight-bold La prise de rendez-vous n'est pas disponible pour ce département.
    - else
      h3.font-weight-bold Sélectionnez le motif de votre RDV :
      - context.unique_motifs_by_name_and_location_type.each do |motif|
        .card.mb-3
          = link_to prendre_rdv_path(context.query.merge(motif_name_with_location_type: motif.name_with_location_type))
            .card-body
              .row
                .col-md
                  h4.card-title.mb-3.mt-0.text-success.font-weight-bold= motif.name
                  h5.card-subtitle.mb-2= motif.human_attribute_value(:location_type)
                  h6.card-subtitle.mb-2= motif.service.name

app/views/search/search_rdv.html.slim
- content_for :header
  = render "banner", context: @context
  = render @context, context: @context